<template>
  <div>
    <ValidationObserver ref="form" v-slot="{ handleSubmit }">
      <v-form @submit.prevent="handleSubmit(submitForm)">
        <div class="mt-4 d-flex flex-row justify-space-between my-3">
          <h1 class="app-title mb-5">Add New Product</h1>
          <div class="action-add d-flex flex-row">
            <v-btn
              type="submit"
              :loading="loading"
              color="#FDB526"
              class="text-center float-right"
              dark
            >
              <span class="text-capitalize">Save Product</span>
            </v-btn>
          </div>
        </div>
        <v-card class="">
          <v-row class="ml-3">
            <v-col cols="3" class="app-box-grey"
              ><p class="app-sub pb-0 mb-0">Photo Product</p></v-col
            >
            <v-col cols="9" class="app-box"
              ><p class="app-sub pb-0 mb-0">Product Information</p></v-col
            >
          </v-row>
          <v-row class="ml-3">
            <v-col class="app-menu text-center" cols="3">
              <app-file-upload
                height="250px"
                @onFileChange="onFileChange"
                :value="ProductImage"
              >
              </app-file-upload>
              <p class="text-grey-light">Maximum size 3 mb</p>
              <p class="text-regular text-left">
                Pro tips: Use photo product with high resolution
              </p>
              <v-btn
                @click="handleTriggerUpload"
                color="#FAFAFA"
                class="text-center w-full"
              >
                <span class="text--primary">Upload Image</span>
              </v-btn>
              <input
                class="d-none"
                type="file"
                @change="handleFileChange"
                ref="file"
              />
            </v-col>
            <!-- product Information -->
            <v-col cols="9" class="pr-7">
              <div>
                <p class="app-title-small ma-0">Product Name</p>
                <ValidationProvider
                  v-slot="{ errors }"
                  name="Username"
                  rules="required"
                >
                  <v-text-field
                    label="Product Name"
                    placeholder="Eg. Tandoori Chicken"
                    :error-messages="errors"
                    v-model="productName"
                    single-line
                    dense
                    filled
                    outlined
                  ></v-text-field>
                </ValidationProvider>
              </div>
              <div>
                <p class="text-blood">Product Price & Variants</p>
                <div :key="index.id" v-for="(row, index) in VariantDynamic">
                  <v-row>
                    <v-col cols="4">
                      <p class="app-title-small ma-0">Variant Name</p>
                      <ValidationProvider
                        v-slot="{ errors }"
                        name="Variant Name"
                        rules="required"
                      >
                        <v-text-field
                          label="Variant Name"
                          placeholder="Eg. Baso"
                          :error-messages="errors"
                          v-model="name[index]"
                          single-line
                          dense
                          filled
                          outlined
                        ></v-text-field>
                      </ValidationProvider>
                    </v-col>
                    <v-col cols="3">
                      <p class="app-title-small ma-0">
                        Product SKU / Product ID
                      </p>
                      <ValidationProvider
                        v-slot="{ errors }"
                        name="Product SKU"
                        rules="required"
                      >
                        <v-text-field
                          label="SKU"
                          placeholder="Eg. SKU-092-ff"
                          :error-messages="errors"
                          v-model="sku[index]"
                          single-line
                          dense
                          filled
                          outlined
                        ></v-text-field>
                      </ValidationProvider>
                    </v-col>
                    <v-col cols="4">
                      <p class="app-title-small ma-0">Product Price</p>
                      <ValidationProvider
                        v-slot="{ errors }"
                        name="Product Price"
                        rules="required"
                      >
                        <v-text-field
                          label="price"
                          placeholder="Eg. 17.000"
                          type="number"
                          v-model="price[index]"
                          :error-messages="errors"
                          prefix="Rp"
                          single-line
                          dense
                          filled
                          outlined
                        ></v-text-field>
                      </ValidationProvider>
                    </v-col>
                    <v-col cols="auto">
                      <div class="pt-7">
                        <v-icon
                          @click.prevent="removeConfigurationRow(index, row)"
                          medium
                          color="red"
                          class="cursor-pointer"
                          >mdi-delete</v-icon
                        >
                      </div>
                    </v-col>
                  </v-row>
                </div>
                <v-btn
                  width="100%"
                  @click="addConfigurationRow(index)"
                  color="#FAFAFA"
                  class="text-center w-full"
                  dark
                >
                  <span class="text-blue-sm">Add Variants</span>
                </v-btn>
              </div>
              <div>
                <p class="text-blood mt-10">Product Modifier</p>
                <div>
                  <v-list three-line flat>
                    <v-list-item-group v-model="item" color="primary">
                      <v-list-item v-for="(item, i) in selected" :key="i">
                        <v-list-item-avatar
                          class="img-popup mt-7"
                          v-if="item.product_image !== null"
                        >
                          <v-img :src="item.product_image"></v-img>
                        </v-list-item-avatar>
                        <v-list-item-avatar class="img-popup mt-7" v-else>
                          <v-img
                            src="https://thefittingsource.com/wp-content/uploads/2017/12/temp-inventory-landing.jpg"
                          ></v-img>
                        </v-list-item-avatar>
                        <v-list-item-content class="py-5">
                          <v-list-item-title
                            v-html="item.product_name"
                          ></v-list-item-title>
                          <v-list-item-subtitle
                            v-html="item.product_id"
                          ></v-list-item-subtitle>
                        </v-list-item-content>
                        <v-list-item-action class="py-5">
                          <v-icon
                            @click.prevent="removeTopings(index)"
                            medium
                            color="red"
                            class="cursor-pointer"
                            >mdi-delete</v-icon
                          >
                        </v-list-item-action>
                      </v-list-item>
                    </v-list-item-group>
                  </v-list>
                </div>
                <v-btn
                  width="100%"
                  @click="modifierShow()"
                  color="#FAFAFA"
                  class="text-center w-full"
                  dark
                >
                  <span class="text-blue-sm">+Add Modifier</span>
                </v-btn>
              </div>
              <div>
                <p class="text-blood mt-10">
                  Recipe, Stock Tracker & Cost (COGS)
                </p>
                <v-card color="#F5F5F5">
                  <v-card-title class="text-blood-sm pb-1"
                    >Use Recipe As Stock Tracker</v-card-title
                  >
                  <v-card-subtitle class="pb-0">
                    <div class="text">
                      <p>
                        Enable this setting to add this product to
                        “<b>Recipes</b>” menu
                      </p>
                      <v-switch v-model="switch1" color="#1DBA81"></v-switch>
                    </div>
                  </v-card-subtitle>
                  <div class="mt-0 pt-0" v-if="switch1 === false">
                    <v-btn color="#F32626" text>Disabled</v-btn>
                  </div>
                  <div class="mt-0 pt-0" v-else>
                    <v-btn color="#1DBA81" text>Enabled</v-btn>
                  </div>
                </v-card>
                <p
                  class="float-right"
                  v-if="switch1 === true"
                  style="color: #1DBA81"
                >
                  *Tracked Product’s stock
                </p>
                <div v-if="productDy">
                  <div
                    :key="index.id"
                    v-for="(row, index) in VariantDynamic"
                    class="mt-5"
                  >
                    <v-row>
                      <v-col cols="3">
                        <p class="app-title-small ma-0">Product Name</p>
                        <v-text-field
                          v-model="name[index]"
                          single-line
                          disabled
                          readonly
                          dense
                          filled
                          outlined
                        ></v-text-field>
                      </v-col>
                      <v-col cols="3">
                        <p class="app-title-small ma-0">Product Cost</p>
                        <v-text-field
                          label="SKU"
                          v-model="cost[index]"
                          placeholder="Eg.Rp.18000"
                          single-line
                          type="number"
                          prefix="Rp"
                          dense
                          filled
                          outlined
                        ></v-text-field>
                      </v-col>
                      <v-col cols="3">
                        <p class="app-title-small ma-0">Qty/day</p>
                        <v-text-field
                          label="price"
                          placeholder="Eg. 200"
                          v-model="qty[index]"
                          type="number"
                          suffix="/Day"
                          single-line
                          dense
                          filled
                          outlined
                        ></v-text-field>
                      </v-col>
                      <v-col cols="3">
                        <p class="app-title-small ma-0">Min Qty</p>
                        <v-text-field
                          label="price"
                          placeholder="Eg. 200"
                          v-model="min[index]"
                          type="number"
                          single-line
                          dense
                          filled
                          outlined
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </div>
                </div>
              </div>
              <v-alert
                v-if="switch1 === true"
                dense
                color="rgba(253, 181, 38, 0.1)"
                class="mt-5"
                ><p>
                  <b>Pro tips:</b> Learn how to use ingredient for tracking your
                  product’s stock
                  <v-icon size="14" class="cursor-pointer">mdi-launch</v-icon>
                </p></v-alert
              >
              <div>
                <p class="text-blood mt-5">Others</p>
                <div>
                  <p class="app-title-small ma-0">Tax</p>
                  <v-select
                    dense
                    :items="TaxList"
                    v-model="taxData"
                    :reduce="text => text.value"
                    outlined
                  ></v-select>
                </div>
              </div>
              <div>
                <p class="app-title-small ma-0">Product’s Tags</p>
                <ValidationProvider
                  v-slot="{ errors }"
                  name="Product Tags number"
                  rules="required"
                >
                  <v-autocomplete
                    ref="tagAutocomplete"
                    v-model="tags"
                    :items="tagList"
                    chips
                    small-chips
                    deletable-chips
                    full-width
                    hide-details
                    hide-no-data
                    hide-selected
                    multiple
                    single-line
                    outlined
                    dense
                    flat
                    placeholder="Eg. Cafe, Cake, Sweet, No smoking "
                    auto-select-first
                    :value="tagInputValue"
                    @change="onTagValueChange"
                    @input="onTagInput"
                    @keyup.enter="submitTag"
                    @keyup.tab="submitTag"
                    :error-messages="errors"
                  ></v-autocomplete>
                </ValidationProvider>
                <p class="black20">
                  This tag will help customer to find your restaurant
                </p>
              </div>
            </v-col>
          </v-row>
        </v-card>
      </v-form>
    </ValidationObserver>
    <!-- modal -->
    <v-dialog v-model="dialog" persistent max-width="450">
      <v-card class="pa-2">
        <v-card-title class="text-blood pl-0 pt-1 pr-0 pb-3"
          >Add Modifier
          <v-spacer></v-spacer>
          <v-icon class="float-right" @click.prevent="dialog = false"
            >mdi-close</v-icon
          >
        </v-card-title>
        <div>
          <p class="text-blood-sm">Search toppings or modifier</p>
          <v-text-field
            v-model="search"
            append-icon="mdi-magnify"
            label="Eg: Egg"
            color="#fdb526"
            single-line
            dense
            filled
            outlined
            hide-details
          ></v-text-field>
          <div class="my-5" style="max-height: 364px; overflow-x:auto">
            <v-data-table
              :headers="headers"
              :items="resmodifier"
              :search="search"
              :items-per-page="itemsPerPage"
              hide-default-header
              hide-default-footer
              class="elevation-1"
              @page-count="pageCount = $event"
            >
              <template v-slot:item.avatar="{ item }">
                <v-row>
                  <v-col
                    cols="2"
                    class="pa-1"
                    v-if="item.product_image !== null"
                  >
                    <v-img
                      :src="item.product_image"
                      style="width:120px; height:48px; border-radius: 4px;"
                      aspect-ratio="1.7"
                    ></v-img>
                  </v-col>
                  <v-col cols="10">
                    <span class="text-blood">{{ item.product_name }}</span
                    ><br />
                    <span>{{ item.product_id }}</span>
                  </v-col>
                </v-row>
              </template>
              <template v-slot:item.outher="{ item }">
                <v-checkbox v-model="selected" :value="item"></v-checkbox>
              </template>
            </v-data-table>
          </div>
        </div>
        <v-card-actions class="pa-0">
          <v-spacer></v-spacer>
          <v-btn
            @click.prevent="addToping(selected)"
            color="#FDB526"
            class="text-center mt-3 w-full"
            width="100%"
            dark
          >
            <span class="text-capitalize">Add Modifier</span>
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import AppFileUpload from "@/components/AppFileUpload";
export default {
  name: "AddProduct",
  components: {
    AppFileUpload
  },
  data() {
    return {
      page: 1,
      pageCount: 0,
      itemsPerPage: 1000,
      search: "",
      item: [],
      selected: [],
      topingsList: [],
      active: false,
      switch1: false,
      dialog: false,
      dialog2: false,
      dialog5: false,
      ProductImage: null,
      loading: false,
      deleteDialog: false,
      tagList: [
        {
          id: 1,
          text: "cafe"
        },
        {
          id: 2,
          text: "Cake"
        },
        {
          id: 3,
          text: "No Smoking"
        },
        {
          id: 4,
          text: "Sweet"
        }
      ],
      tagInputValue: "",
      headers: [
        {
          text: "",
          align: "start",
          value: "avatar"
        },
        { text: "", value: "outher", sortable: false }
      ],
      TaxList: [
        {
          id: 1,
          text: "PPN (10%)"
        },
        {
          id: 2,
          text: "PPH (5%)"
        }
      ],
      ProductUnitList: [],
      ProductCatList: [],
      productDy: true,
      productDynamic: [0],
      VariantDynamic: [0],
      popupSuccess: true,
      dialogsuccess: false,
      errorMessage: false,
      // models
      productName: null,
      category: null,
      unit: null,
      taxData: null,
      taxActive: false,
      tags: [],
      name: [],
      sku: [],
      price: [],
      qty: [],
      min: [],
      cost: [],
      // tampung
      tempCate: null,
      deleteModif: [],
      deleteVariant: [],
      temptags: [],
      tempname: [],
      tempsku: [],
      tempprice: [],
      tempqty: [],
      tempmin: [],
      tempcost: [],
      titleSuccess: null,
      resmodifier: [
        {
          product_id: "KZX-222w",
          product_name: "Telur",
          product_image:
            "https://media.suara.com/pictures/970x544/2014/03/10/shutterstock_99363011.jpg"
        },
        {
          product_id: "KZX-222w",
          product_name: "Terigu",
          product_image:
            "https://asset-a.grid.id/crop/0x0:0x0/700x465/photo/2019/06/15/688004011.jpg"
        },
        {
          product_id: "KZX-222w",
          product_name: "Saus",
          product_image:
            "https://doktersehat.com/wp-content/uploads/2019/09/saus-tomat-doktersehat.jpg"
        }
      ]
    };
  },
  computed: {},
  mounted() {},
  watch: {
    tagsList(newVal) {
      newVal.forEach(data => {
        this.tagList.push(data.tag_name);
      });
    },
    unitList(newval) {
      newval.forEach(item => {
        this.ProductUnitList.push({
          text: item.unit_name,
          value: item.unit_id
        });
      });
    },
    categories(newval) {
      newval.forEach(item => {
        this.ProductCatList.push({
          text: item.category_name,
          value: item.category_id
        });
      });
    },
    tax(newval) {
      newval.forEach(item => {
        var taxjoin = item.tax_name.concat(" (" + item.tax_value + "%)");
        this.TaxList.push({
          text: taxjoin,
          value: item.tax_id
        });
      });
    },
    switch1(newVal) {
      if (newVal === true) {
        this.productDy = false;
      } else {
        this.productDy = true;
      }
    }
  },
  methods: {
    modifierShow() {
      this.dialog = true;
    },
    deleteConfrim() {
      this.deleteDialog = true;
    },
    goToNavigate() {
      this.popupSuccess = false;
    },
    addConfigurationRow: function(i) {
      this.VariantDynamic.push([i]);
    },
    removeConfigurationRow: function(index, val) {
      this.VariantDynamic.splice(index, 1);
      this.name.splice(index, 1);
      this.sku.splice(index, 1);
      this.price.splice(index, 1);
      this.cost.splice(index, 1);
      this.qty.splice(index, 1);
      this.min.splice(index, 1);
      this.deleteVariant.push(val);
    },
    removeTopings: function(index) {
      this.selected.splice(index, 1);
    },
    handleTriggerUpload() {
      this.$refs.file.click();
    },
    handleFileChange(e) {
      const input = e.target || this.$refs.file;
      const file = input.files ? input.files[0] : null;

      this.onFileChange(file);
    },
    onFileChange(file) {
      this.ProductImage = file;
    },
    onTagValueChange() {},
    onTagInput() {},
    addToping() {
      this.dialog = false;
    },
    submitTag(e) {
      const value = e.target.value;
      if (value) {
        const stringToMatch = new RegExp(value, "g");
        const filter = this.tagList.filter(item => {
          return !!item.match(stringToMatch);
        });

        if (filter.length === 0) {
          const filterValue = this.tags.filter(item => {
            return item === value;
          });
          if (filterValue.length === 0) {
            e.target.value = "";
            this.tagList.push(value);
            this.tags.push(value);
          }
        }
      }
    },
    // submit

    closeAndNavigate() {
      setTimeout(() => {
        this.$router.push("/products");
      }, 200);
    },
    submitDelete() {
      this.$store.commit("product/SET_idProductEdit", this.$route.params.id);
      this.$store
        .dispatch("product/deleteProduct")
        .then(response => {
          console.log(response);
          const res = response.data;
          if (res.status === true) {
            this.deleteDialog = false;
            this.titleSuccess = "Product has been Deleted";
            this.dialogsuccess = true;
          } else {
            this.deleteDialog = false;
            this.dialogFailed = true;
            console.log(res.errors);
          }
        })
        .catch(error => {
          const message = error.response.data.message;
          if (error.response.status === 400) {
            // this.$refs.form.setErrors({
            //   Email: [message],
            //   Username: [message]
            // })
            this.deleteDialog = false;
          } else {
            this.errorMessage = message;
            this.deleteDialog = true;
          }
        });
    },
    submitForm() {
      this.loading = true;
      var tempProduct = {};
      if (this.tax !== null) {
        this.taxActive = true;
      } else {
        this.taxActive = false;
      }
      if (this.switch1 === true) {
        this.recipe = true;
      } else {
        this.recipe = true;
      }
      // tempProduct.product_image = this.ProductImage
      tempProduct.product_name = this.productName;
      tempProduct.product_category_id = this.category;
      tempProduct.unit_id = this.unit;
      tempProduct.recipe_stock_cost_tracker = this.recipe;
      tempProduct.tax = this.taxActive;
      tempProduct.tax_id = this.taxData;

      // coding dibawah mengikuti kebutuhan api
      this.tags.forEach((element, index) => {
        var tags = "product_tags[" + index + "]";
        tempProduct[tags] = element;
      });
      this.selected.forEach((element, index) => {
        var toping = "product_modifiers[" + index + "][modifier_id]";
        tempProduct[toping] = element.product_id;
      });
      this.name.forEach((element, index) => {
        var vname = "product_variants[" + index + "][variant_name]";
        tempProduct[vname] = element;
      });
      this.sku.forEach((data, index) => {
        var vsku = "product_variants[" + index + "][variant_sku]";
        tempProduct[vsku] = data;
      });
      this.price.forEach((element, index) => {
        var vsell = "product_variants[" + index + "][variant_sell_price]";
        tempProduct[vsell] = element;
      });
      this.cost.forEach((element, index) => {
        var vbuy = "product_variants[" + index + "][variant_buy_price]";
        tempProduct[vbuy] = element;
      });
      this.qty.forEach((element, index) => {
        var vmin = "product_variants[" + index + "][variant_qty_perday]";
        tempProduct[vmin] = element;
      });
      this.min.forEach((element, index) => {
        var vmin = "product_variants[" + index + "][variant_min_qty]";
        tempProduct[vmin] = element;
      });

      var formData = new FormData();
      for (var key in tempProduct) {
        formData.append(key, tempProduct[key]);
      }
      console.log(formData);
      // this.$store.commit("MODULES/MUTATION", formData); //change
      // this.$store
      //   .dispatch("MODULES/NAME_ACTIONS") //change
      //   .then(response => {
      //     const res = response.data;
      //     const messagesSuccess = res.status.message;
      //     if (res.status) {
      this.loading = false;
      this.$swal.fire("Success!!", "berhasil", "success").then(result => {
        if (result.isConfirmed) {
          this.$router.go();
          // this.$router.go(-1) backto sebelumnya

          // this.$router.go() backto sebelumnya
        }
      });
      //   }
      // })
      // .catch(error => {
      //   this.loading = false;
      //   const messagesError = error.response.data.status.message;
      //   this.$swal.fire("Error!!", messagesError, "error");
      // });
    }
  }
};
</script>
<style lang="scss" scoped>
.text {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  align-items: center;
}
.img-popup {
  width: 48px !important;
  height: 100%;
  border-radius: 5px !important;
}
</style>
